<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
<!--      <template slot="menuLeft">-->
<!--        <el-button type="danger"-->
<!--                   size="small"-->
<!--                   icon="el-icon-delete"-->
<!--                   plain-->
<!--                   v-if="permission.elevatoralarm_delete"-->
<!--                   @click="handleDelete">删 除-->
<!--        </el-button>-->
<!--      </template>-->
      <template slot="menu" slot-scope="{row}">
        <el-button icon="el-icon-video-camera" v-if="'1000007,1000010,1000018,1000050'.indexOf(row.alarmType) != -1" type="text" @click="getAlarmVideoData(row)">查看告警视频</el-button>
      </template>
    </avue-crud>

    <!--  告警视频  -->
    <el-dialog :append-to-body="true" :close-on-click-modal="false" :modal-append-to-body="false" width="40%" top="1vh"
               :title="videoAlarmName" :visible.sync="videoAlarmVisible" @close="videoClose">
      <video id="videoAlarm" autoplay  style="background-color: black; width:100%;height:100%"></video>
    </el-dialog>

  </basic-container>
</template>

<script>
import {getList, getDetail, add, update, remove} from "@/api/device/elevatoralarm";
import {getAlarmVideo} from "@/api/device/elevatordevice";
import {mapGetters} from "vuex";
import {startPlay, stopPlay} from "@/api/device/elevatorUtil";

export default {
  name: "elevatorAlarm",
  data() {
    return {
      form: {},
      query: {},
      videoAlarmName: '',
      videoAlarmVisible: false,
      player: null,
      loading: true,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        height:'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        addBtn: false,
        editBtn: false,
        delBtn: false,
        viewBtn: true,
        selection: true,
        dialogClickModal: false,
        menuWidth:350,
        column: [
          /*{
            label: "告警编号",
            prop: "alarmCode",
            rules: [{
              required: true,
              message: "请输入告警编号",
              trigger: "blur"
            }]
          },
          {
            label: "电梯注册编码",
            prop: "registerCode",
            rules: [{
              required: true,
              message: "请输入电梯注册编码",
              trigger: "blur"
            }]
          },*/
          {
            label: "小区名称",
            prop: "residentialName",
            // search: true,
            // searchSpan: 4,

          },
          {
            label: "小区",
            prop: "residentialId",
            type: "select",
            hide: true,
            search: true,
            searchSpan: 4,
            searchFilterable: true,
            // remote: true,
            //回显的时候有问题，如果所选不在前十条内，下拉框只会显示id
            dicUrl: "/api/cyzh-community/residential/list?size=1000&name={{key}}",
            // dicUrl: "/api/community/elevator/elevator/getListWithYtelevatorXq",
            props:{
              label: "name",
              value: "id"
            },
            dicFormatter: (res)=>{
              return res.data.records;
            },
          },
          {
            label: "告警大类",
            prop: "standardType",
            type: "select",
            search: true,
            searchSpan: 4,
            dicUrl: "/api/blade-system/dict-biz/dictionary?code=yt_standard_type",
            props:{
              label: "dictValue",
              value: "dictKey",
            },
            rules: [{
              required: true,
              message: "请输入告警大类{9000001:报警 ,9000002:故障, 9000004:事件}",
              trigger: "blur"
            }]
          },
          {
            label: "告警类型",
            prop: "alarmType",
            type: "select",
            search: true,
            searchSpan: 4,
            dicUrl: "/api/blade-system/dict-biz/dictionary?code=yt_alarm_type",
            props:{
              label: "dictValue",
              value: "dictKey",
            },
            rules: [{
              required: true,
              message: "请输入告警类型",
              trigger: "blur"
            }]
          },
          {
            label: "告警状态",
            prop: "alarmStatus",
            type: "select",
            search: true,
            searchSpan: 4,
            dicUrl: "/api/blade-system/dict-biz/dictionary?code=yt_alarm_status",
            dataType: "number",
            props:{
              label: "dictValue",
              value: "dictKey",
            },
            rules: [{
              required: true,
              message: "请输入告警状态{1：告警中，6：自动结束，7：超期结束，8：自动处理}",
              trigger: "blur"
            }]
          },
          {
            label: "告警时间",
            prop: "alarmTime",
            rules: [{
              required: true,
              message: "请输入告警时间",
              trigger: "blur"
            }]
          },
          {
            label: "告警结束时间",
            prop: "alarmEndTime",
            rules: [{
              required: true,
              message: "请输入告警结束时间",
              trigger: "blur"
            }]
          },

          {
            label: "云梯状态",
            prop: "ytStatus",
            type: "select",
            search: true,
            searchSpan: 4,
            dicUrl: "/api/blade-system/dict-biz/dictionary?code=yt_status",
            props:{
              label: "dictValue",
              value: "dictKey",
            },
            rules: [{
              required: true,
              message: "请输入云梯告警状态{20：正常，40：演示，50：测试}",
              trigger: "blur"
            }]
          },
        ]
      },
      data: []
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.elevatoralarm_add, false),
        viewBtn: this.vaildData(this.permission.elevatoralarm_view, false),
        delBtn: this.vaildData(this.permission.elevatoralarm_delete, false),
        editBtn: this.vaildData(this.permission.elevatoralarm_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  props:["registerCode"],
  methods: {
    videoClose(){
      stopPlay(this.player);
    },
    getAlarmVideoData(row){
      let alarmCode = row.alarmCode;
      this.videoAlarmName = row.$alarmType;
      this.videoAlarmVisible = true;
      alarmCode && getAlarmVideo(alarmCode).then(res => {
        if (res.data.code == 200 && res.data.data.code == 0){
          let videoUrl = res.data.data.data.urlSec;
          this.videoDetail(videoUrl);
        }
      });

    },
    videoDetail(videoUrl){
      let elementId = 'videoAlarm';
      this.player = startPlay(elementId, videoUrl, this.player);
    },
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        window.console.log(error);
      });
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        console.log(error);
      });
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.$refs.crud.toggleSelection();
        });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage){
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize){
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      params.registerCode = this.registerCode;
      if (params.registerCode){
        this.option.column[1].search = false;
      }
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
